Subject: [Idr] some thoughts on draft-ietf-idr-bgp-model-09.txt

From: tom petch <[email-masked]>
Date: Mon, 3 Aug 2020 09:30:55 +0000

This I-d needs a significant amount of work; for me it has a slight flavour of a large project that has been subcontracted out and now needs (more) systems integration.

I note that it uses submodules extensively, not something I can recall seeing in an IETF module.

The YANG references 32 documents - good - of which 11 are missing from the I-D references - not good.

scharf-tcpm-yang-tcp is an import and so MUST be a Normative (think about it; TCPM just published an I-D that started life 10 years ago, while NETCONF started work on modelling TCP many years ago and have yet to reach WGLC).

Do submodule names need registering? 
"   Names of submodules published in RFC streams [RFC4844] MUST be
   assigned by IANA; see Section 14 in [RFC6020]."
That's another 12 entries needed in IANA.

There are 11 include by date which means that more recent versions will not be picked up and that there are 11 places where the RFC editor must insert the right date, probably something they have not done before.

YANG allows freedom over the choice of prefix but exercising that freedom is not always helpful.  'bgp' is the obvious choice for the main module.  Elsewhere, with main and ancillary modules, a common pattern is for the main to be e.g. axy and the ancillary axy...

Two letter prefix are best reserved for widely imported modules - interfaces comes to mind. 'bt' will be a familiar abbreviation to many in the IETF while 'bp' will have a resonance for those living near the Gulf of Mexico.

A table of imports and prefix used aids comprehension.

derived-from-or-self suggests that you expect other protocol to derive an identity from bgp; what do you have in  mind?

action to clear neighbours can be invoked by anyone; perhaps a security exposure.  'These ... operations ...' seems incomplete.

Overall, I wonder at the use of submodules.  Greater size, greater complexity, more difficult to review, probably more mistakes; what benefit offsets this?

From: Idr <[email-masked]> on behalf of Susan Hares <[email-masked]>
Sent: 31 July 2020 17:42
To: [email-masked]
Subject: Re: [Idr] IPR call prior to WG LC for draft-ietf-idr-bgp-model-09.txt

---

From: tom petch <[email-masked]>
Date: Mon, 3 Aug 2020 09:38:17 +0000

Sue

Since you are listed as an author of this I-D, it would seem appropriate if your co-chair was the one responsible for taking this I-D forward in all its processes, starting with this call.

Tom Petch
________________________________________
From: Idr <[email-masked]> on behalf of Susan Hares <[email-masked]>
Sent: 29 July 2020 12:41
To: [email-masked]
Subject: [Idr] IPR call prior to WG LC for draft-ietf-idr-bgp-model-09.txt

This begins an IPR call in preparation for a WG LC on draft-ietf-idr-bgp-model-09.txt.

Cheerily, Susan Hares

---

From: "Scharf, Michael" <[email-masked]>
Date: Mon, 3 Aug 2020 09:45:11 +0000

Tom,

One comment on a detail...

> scharf-tcpm-yang-tcp is an import and so MUST be a Normative (think about
> it; TCPM just published an I-D that started life 10 years ago,

draft-scharf-tcpm-yang-tcp-00 (i.e., the first version of a YANG model discussed in TCPM) was published in Oct. 2018.  I am subscribed to the TCPM mailing list for at least 15 years. And I don't recall any earlier work regarding YANG in TCPM.

All,

TCPM currently confirms WG adoption of draft-scharf-tcpm-yang-tcp on the TCPM list. Feedback from the IDR community would be very welcome.

Michael (as contributor)

---

From: tom petch <[email-masked]>
Date: Mon, 3 Aug 2020 10:06:16 +0000

From: Scharf, Michael <[email-masked]>
Sent: 03 August 2020 10:45

Tom,

<tp>
Michael

My comment was incomplete; I was not referring to work on YANG in TCPM that took 10 years  but to work on other aspects of TCP that took place in TCPM and took a while to complete.  WG progress at the pace they progress at and other WG have little influence thereon.  My review of idr-bgp-model was in fact triggered by an e-mail mentioning it as one of a number of I-D that were Normatively dependent on a draft from MPLS WG so Normative dependencies and the delays that they induce were fresh in my mind as I reviewed the idr draft.

Tom Petch

All,

Michael (as contributor)

---

From: "Susan Hares" <[email-masked]>
Date: Wed, 5 Aug 2020 07:01:58 -0400

Tom: 

John and Jie will be taking forward the processes. John will have the final
judgement judging the IPR call and consensus.   Starting the IPR call is not
normally seen as conflicting.   

If you have concerns about my starting the IPR call,  I can ask John to
start the IPR call again noting that I am a co-author. 

Sue 

-----Original Message-----
From: tom petch [mailto:[email-masked]] 
Sent: Monday, August 3, 2020 5:38 AM
To: Susan Hares; [email-masked]
Cc: John Scudder
Subject: Re: [Idr] IPR call prior to WG LC for
draft-ietf-idr-bgp-model-09.txt

Sue

Since you are listed as an author of this I-D, it would seem appropriate if
your co-chair was the one responsible for taking this I-D forward in all its
processes, starting with this call.

Tom Petch

This begins an IPR call in preparation for a WG LC on
draft-ietf-idr-bgp-model-09.txt.

Cheerily, Susan Hares

---

From: "Susan Hares" <[email-masked]>
Date: Wed, 5 Aug 2020 07:17:03 -0400

Tom: 

Thank you for the comments.    The history of the BGP model has a long
history and it a large project.    Your feeling is probably correct.. but
we'll try to address these issues.   The sub-modules were the wisdom at the
start of this work. 

As to the missing references, we'll ask John to hold the start of WG LC
until we address your comments.  This model is also out at the Yang Doctors
to review prior to start of WG LC.   

I am on vacation this week and most of next week. I saw your emails and I
wanted to make sure you got a response.   I'll dig in once I'm back full
time.   

Thanks for pointing things out. 

Sue 

-----Original Message-----
From: tom petch [mailto:[email-masked]] 
Sent: Monday, August 3, 2020 5:31 AM
To: Susan Hares; [email-masked]
Subject: some thoughts on draft-ietf-idr-bgp-model-09.txt

This I-d needs a significant amount of work; for me it has a slight flavour
of a large project that has been subcontracted out and now needs (more)
systems integration.

I note that it uses submodules extensively, not something I can recall
seeing in an IETF module.

The YANG references 32 documents - good - of which 11 are missing from the
I-D references - not good.

scharf-tcpm-yang-tcp is an import and so MUST be a Normative (think about
it; TCPM just published an I-D that started life 10 years ago, while NETCONF
started work on modelling TCP many years ago and have yet to reach WGLC).

There are 11 include by date which means that more recent versions will not
be picked up and that there are 11 places where the RFC editor must insert
the right date, probably something they have not done before.

YANG allows freedom over the choice of prefix but exercising that freedom is
not always helpful.  'bgp' is the obvious choice for the main module.
Elsewhere, with main and ancillary modules, a common pattern is for the main
to be e.g. axy and the ancillary axy...

Two letter prefix are best reserved for widely imported modules - interfaces
comes to mind. 'bt' will be a familiar abbreviation to many in the IETF
while 'bp' will have a resonance for those living near the Gulf of Mexico.

derived-from-or-self suggests that you expect other protocol to derive an
identity from bgp; what do you have in  mind?

action to clear neighbours can be invoked by anyone; perhaps a security
exposure.  'These ... operations ...' seems incomplete.

Overall, I wonder at the use of submodules.  Greater size, greater
complexity, more difficult to review, probably more mistakes; what benefit
offsets this?

---

From: tom petch <[email-masked]>
Date: Wed, 5 Aug 2020 11:43:07 +0000

From: Susan Hares <[email-masked]>
Sent: 05 August 2020 12:01

Tom:

<tp>
No, no need to go that far, John will do the right thing.

On a related point, for John to consider, some WG Chair solicit IPR from Contributors as well as Authors and this I-D has a number of the former and the early version had a very different list of Authors most of whom are now Contributors, one I think not.  I do not know what is meant to happen in such a case but I will go along with whatever John decides.

Tom Petch.

Sue

-----Original Message-----
From: tom petch [mailto:[email-masked]]
Sent: Monday, August 3, 2020 5:38 AM
To: Susan Hares; [email-masked]
Cc: John Scudder
Subject: Re: [Idr] IPR call prior to WG LC for

Sue

Tom Petch

Cheerily, Susan Hares

---

From: John Scudder <[email-masked]>
Date: Wed, 5 Aug 2020 11:47:56 +0000

Thanks for the input, Tom. Of course the IPR call is more in the nature of a reminder than a requirement since in principle the whole WG has this obligation; nonetheless I’ll keep it in mind. 

—John

> On Aug 5, 2020, at 7:43 AM, tom petch <[email-masked]> wrote:
> 
> [External Email. Be cautious of content]
> 
>

---

From: tom petch <[email-masked]>
Date: Thu, 6 Aug 2020 09:17:10 +0000

From: Susan Hares <[email-masked]>
Sent: 05 August 2020 12:17

Tom:

Sue, John

I floated the question of the benefits of submodules on the NETMOD list to which everyone, so far, except Mahesh, said there are none and should be removed from YANG 2.  This I-D would be easier for me to review without submodules; the fact that the submodule names must be registered with IANA and are not in this I-D suggests to me an incomplete grasp of submodules.  I will be interested to see what the YANG doctor says in this regard.

Apart from submodules, the other big showstopper to my comprehension is prefix, with inconsistent use of prefix and the wrong prefix being used for existing, published modules.  YANG allows you to change the prefix - 'YANG Guidelines ' does not.  Along with the use of br.. prefix, there are probably over 100 places in this I-D where the prefix must be changed to conform to the rules.  Look for example at routing policy where rpol: is (mis)used instead of rt-pol:

This could be an interesting Last Call.

Sue, I hope you can get away from it all for your vacation.

Tom Petch

Sue

---

From: tom petch <[email-masked]>
Date: Mon, 17 Aug 2020 09:06:36 +0000

From: Idr <[email-masked]> on behalf of tom petch <[email-masked]>
Sent: 06 August 2020 10:17

Tom:

<tp>

Sue, John

I have seen Acee's review of this I-D and agree with him, especially about submodules, so I shall put this on hold until I see a resolution to the issues he raises (regardless of whether or not a revised I-D appears which addresses the issues that I raised).

Tom Petch

Sue, John

Tom Petch

Sue

-----Original Message-----
From: tom petch [mailto:[email-masked]]
Sent: Monday, August 3, 2020 5:31 AM
To: Susan Hares; [email-masked]
Subject: some thoughts on draft-ietf-idr-bgp-model-09.txt

_______________________________________________
Idr mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/idr